
Ruby - Bug #7884

Tkで，コマンドにforkを入れると，イベント実行時にクラッシュする

02/19/2013 11:07 PM - hirura (Hiroyuki URANISHI)

Status: Rejected   

Priority: Normal   

Assignee: nagai (Hidetoshi Nagai)   

Target version: 2.1.0   

ruby -v: ruby 1.9.3p385 (2013-02-06 revision

39114) [universal.x86_64-darwin10]

Backport:  

Description

題名の通りです．

MacPortsからインストールした

1.9.3-p327+mactk

1.9.3-p385+mactk

で同じ症状でした．

以下，ソースです．forkブロック中の，p 'forked process'は表示されます．ウィンドウ終了しませんでした．

require 'tk'

tkroot = TkRoot.new

content = Tk::Tile::Frame.new( tkroot ).grid

Tk::Tile::Button.new( content ){

text 'OK'

command{

pid = fork{ p 'forked process' }

th = Process.detach( pid )

p th.value

}

}.grid

Tk.mainloop

History

#1 - 02/22/2013 08:48 AM - ko1 (Koichi Sasada)

- Category set to ext

- Assignee set to nagai (Hidetoshi Nagai)

- Target version set to 2.1.0

#2 - 06/17/2013 02:19 PM - nagai (Hidetoshi Nagai)

- Status changed from Open to Rejected

少なくとも現状では，callback 中の fork は非サポートです．

通常，callback は eventloop が走っている thread で実行されます．

しかも，callback が実行される際には Tcl 側と Ruby 側との処理が絡み合っています．

この状況でウィンドウシステムのイベント処理を行う thread が複製された時に生じることについて，

私には保証しきれません．

Files

ruby1.9_2013-02-19-223306_mu.crash 34.7 KB 02/19/2013 hirura (Hiroyuki URANISHI)

terminal_log.txt 6.27 KB 02/19/2013 hirura (Hiroyuki URANISHI)
